
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PHP单元测试利器 PHPUNIT初探第1/2页 / iVAN</title>

    <meta name="description" content="PHP单元测试利器 PHPUNIT初探第1/2页 当你遇到以上这些令你沮丧的情况时,你一定会想能有什么更好的办法去解决呢?办法当然是有的!这就是使用单元测试.单元测试不但可以在一定程度上解决上述头疼的问题,而且能让代码变的容易维护,还可以能让你更多地对代码进行重构. 一旦你编写好单元测试用例,当你需要修改你的代码时,你要做的事情就是重新运行你的单元测试用例并观察这些单元测试用例能否通过,如果通过了的话,证明代码是没问题的. 人们往往会说:既然单元测试这么好,为什么那么多人还是不大愿意去写单元测试呢?有以下几种理解上的误曲: 1.认为编写单元测试">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">PHP单元测试利器 PHPUNIT初探第1/2页</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>当你遇到以上这些令你沮丧的情况时，你一定会想能有什么更好的办法去解决呢?办法当然是有的!这就是使用单元测试。单元测试不但可以在一定程度上解决上述头疼的问题，而且能让代码变的容易维护，还可以能让你更多地对代码进行重构。<br />
<br />　　一旦你编写好单元测试用例，当你需要修改你的代码时，你要做的事情就是重新运行你的单元测试用例并观察这些单元测试用例能否通过，如果通过了的话，证明代码是没问题的。</p>
<p>　　人们往往会说：既然单元测试这么好，为什么那么多人还是不大愿意去写单元测试呢?有以下几种理解上的误曲：</p>
<p>　　1、认为编写单元测试太浪费时间。虽然目前很多IDE工具都为编写单元测试建立好了框架，但还是要开发者编写一些单元测试的代码的。就象很多开发中的最佳实践一样，用正确的方法去做正确的事情会为开发节省大量的时间。每当新增加新功能时，你可能通过访问你的网页到处去点击手动测试，而运行建立好的单元测试用例其速度其实比通过手工去测试的速度更快。</p>
<p>　　2、认为既然代码能运行了，不需要再编写单元测试。但假设团队中有新的成员，如果没有良好的单元测试用例，新成员很有可能随意地去编码而不考虑各种后果。如果有编写良好的单元测试，在程序运行时进行各种测试，则能最大程度避免bug的产生。</p>
<p>　　3、认为编写单元测试代码枯燥无味。程序员的天性是解决问题，而很多程序员认为在紧张的编码工作时，还要编写单元测试代码，会很枯燥。但要知道的是，如果能通过编写单元测试在很早的阶段就能尽可能发现代码中多的错误的话，那么既节省时间减少了出错，何乐而不为?</p>
<p>　　<b>开始动手安装phpunit</b></p>
<p>　　本文中将通过介绍php中的单元测试利器phpunit(http://phpunit.de/),并通过实际例子来讲解如何在实际工作中运用phpunit。首先安装phpunit的方法可以通过php下的pear去安装：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">　　pear channel-discover pear.phpunit.de<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">　　pear channel-discover components.ez.no<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">　　pear channel-discover pear.symfony-project.com<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    pear install phpunit/PHPUnit<br />
<br />　　如果你想通过手动方式去安装，可以参考phpunit的手册去安装(http://www.phpunit.de/manual/3.0/en/installation.html)。</p>
<p>　　<b>编写第一个单元测试用例</b></p>
<p>　　下面我们开始编写第一个单元测试用例。在编写测试用例时，要遵守如下的phpunit的规则：</p>
<p>　　1　一般地，在测试用例中，可以扩展PHPUnit_Framework_TestCase类，这样就可以使用象setUp(),tearDown()等方法了。</p>
<p>　　2 测试用例的名字最好是使用约定俗成的格式，即在被测试类的后面加上”Test”,比如要测试的类为RemoteConnect,则测试用例的命名为RemoteConnectTest。</p>
<p>　　3 在一个测试用例中的所有的测试方法，在命名时都应该以test+测试方法名去命名，如testDoesLikeWaffles(),要注意的是该方法必须是声明为public类型的。当然可以在你的测试用例中包含private的方法，但它们不能被phpunit所调用。</p>
<p>　　4 测试方法中是不能接收参数的。</p>
<p>　　下面首先举个简单的例子，代码如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">&lt;?php<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">class RemoteConnect<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">{<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  public function connectToServer($serverName=null)<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  {<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    if($serverName==null){<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">      throw new Exception(“That"s not a server name!”);<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    }<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    $fp = fsockopen($serverName,80);<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    return ($fp) ? true : false;<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  }<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  public function returnSampleObject()<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  {<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    return $this;<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  }<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">}<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">?&gt;<br />
<br />　　上面的代码其实是实现连接到一个指定的服务器的功能，那么我们可以编写测试代码如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">&lt;?php<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">require_once("RemoteConnect.php");<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">class RemoteConnectTest extends PHPUnit_Framework_TestCase<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">{<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  public function setUp(){ }<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  public function tearDown(){ }<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  public function testConnectionIsValid()<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  {<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    // test to ensure that the object from an fsockopen is valid<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    $connObj = new RemoteConnect();<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    $serverName = "www.google.com";<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">    $this-&gt;assertTrue($connObj-&gt;connectToServer($serverName) !== false);<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">  }<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">}<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vTm9uZS5naWY=.jpg">?&gt;<br />
<br />　　在上面的代码中，由于继承了PHPUnit_Framework_TestCase类，因此在setUp和tearDown方法中，不需要编写任何代码。SetUp方法是在每个测试用例运行前进行一些初始化的工作，而tearDown则在每个测试用例运行后进行一些比如资源的释放等工作。在测试方法中，通过使用phpunit的断言assertTrue去判断所返回的布尔值是否为真，这里是通过调用RemoteConnect.php中的connectToServe方法去判断能否连接上服务器。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-02 20:43:33</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e4%bb%a3%e7%a0%81/" title="代码">代码</a>, <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/%e5%8d%95%e5%85%83%e6%b5%8b%e8%af%95/" title="单元测试">单元测试</a>, <a href="https://www.iamivan.net/tag/phpunit/" title="phpunit">phpunit</a>, <a href="https://www.iamivan.net/tag/pear/" title="pear">pear</a>, <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95%e9%80%9a%e8%bf%87/" title="测试通过">测试通过</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>PHP单元测试利器 PHPUNIT初探第1/2页的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGd85p.html" rel="bookmark">PHP单元测试利器 PHPUNIT初探第1&sol;2页&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当你遇到以上这些令你沮丧的情况时,你一定会想能有什么更好的办法去解决呢?办法当然是有的!这就是使用单元测试.单元测试不但可以在一定程度上解决上述头疼的问题,而且能让代码变的容易维护,还可以能让你更多地对代码进行重构. 一旦你编写好单元测试用例,当你需要修改你的代码时,你要做的事情就是重新运行你的单元测试用例并观察这些单元测试用例能否通过,如果通过了的话,证明代码是没问题的. 人们往往会说:既然单元测试这么好,为什么那么多人还是不大愿意去写单元测试呢?有以下几种理解上的误曲: 1.认为编写单元测试			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zeYDVz.html" rel="bookmark">PHP单元测试利器 PHPUNIT深入用法&lpar;三&rpar;第1&sol;2页</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在本文中,笔者将为大家介绍phpunit中的两个高级概念和用法,尽管它不一定在你的日常单元测试中都用到,但理解和学会它们的用法对学习phpunit还是十分重要的. Phpunit中的Annotations 如果有其他编程语言经验的开发者,应该对Annotations(注解)不陌生,其实在phpunit中,一个简单的如下面的一段注释也可以认为是Annotations: &lt;?phpclass MyTestClass extends PHPUnit_Framework_TestCase{/*** Te			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0WeJ8b.html" rel="bookmark">PHP单元测试利器 PHPUNIT深入用法&lpar;三&rpar;第1&sol;2页&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在本文中,笔者将为大家介绍phpunit中的两个高级概念和用法,尽管它不一定在你的日常单元测试中都用到,但理解和学会它们的用法对学习phpunit还是十分重要的. Phpunit中的Annotations 如果有其他编程语言经验的开发者,应该对Annotations(注解)不陌生,其实在phpunit中,一个简单的如下面的一段注释也可以认为是Annotations: &lt;?phpclass MyTestClass extends PHPUnit_Framework_TestCase{/*** Te			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b24jNVp.html" rel="bookmark">PHP单元测试利器 PHPUNIT深入用法&lpar;二&rpar;第1&sol;2页&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.markTestSkipped和markTestIncomplete 在phpunit中,有两个有用的方法markTestSkipped和markTestIncomplete.它们能允许你编写的单元测试中不单是只有通过和失败两种结果.markTestSkipped能让PHPUNIT不去执行某个已经编写好的测试方法.举个例子说明,比如下面的程序: &lt;?phppublic function testThisMightHaveADb(){  $myObject-&gt;createObject(); 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMlDrOM.html" rel="bookmark">初探PHP单元测试利器：PHPUnit</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				你是否在程序开发的过程中遇到以下的情况:当你花了很长的时间开发一个PHP应用后,你认为应该是大功告成了,可惜在调试的时候,老是不断的发现bug,而且最可怕的是,这些bug是重复出现的,你可能发现这些bug之间会有关联,但却老是找不到问题的所在. 当你遇到以上这些令你沮丧的情况时,你一定会想能有什么更好的办法去解决呢?办法当然是有的!这就是使用单元测试.单元测试不但可以在一定程度上解决上述头疼的问题,而且能让代码变的容易维护,还可以能让你更多地对代码进行重构. 一旦你编写好单元测试用例,当你需要修			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/lpPVvAb.html" rel="bookmark">PHP单元测试利器：PHPUNIT初探</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 你是否在程序开发的过程中遇到以下的情况:当你花了很长的时间开发一个应用后,你认为应该是大功告成了,可惜在调试的时候,老是不断的发现bug,而且最可怕的是,这些bug是重复出现的,你可能发现这些bug之间会有关联,但却老是找不到问题的所在. 当你遇到以上这些令你沮丧的情况时,你一定会想能有什么更好的办法去解决呢?办法当然是有的!这就是使用单元测试.单元测试不但可以在一定程度上解决上述头疼的问题,而且能让代码变的容易维护,还可以能让你更多地对代码进行重构. 一旦你编写好单元测试用例,当你需要修改你			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrlN4z.html" rel="bookmark">PHP单元测试利器：PHPUNIT深入用法&lpar;二&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇PHP单元测试利器:PHPUNIT初探文章中,我们对phpunit有了一个初步的认识,在本文中将继续深入讲解下phpunit中的一些用法. 1.markTestSkipped和markTestIncomplete 在phpunit中,有两个有用的方法markTestSkipped和markTestIncomplete.它们能允许你编写的单元测试中不单是只有通过和失败两种结果.markTestSkipped能让PHPUNIT不去执行某个已经编写好的测试方法.举个例子说明,比如下面的程序:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Q8Kap.html" rel="bookmark">Windows下安装PHP单元测试环境PHPUnit图文教程&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.按照常规下载 php 的zip包和配置好 php.ini,这里的例子使用的是 E:\php 2.把你的 php 目录加入系统环境变量 path 中 3.开始 运行 输入 cmd,然后切换到你的 php 目录,我当前的就是 E:\php 4.输入 go-pear.bat 首先脚本会询问是把 pear 安装为系统范围的还是本地拷贝,这里我们默认选择系统,直接回车即可 5.这时显示当前的路径配置,并询问你是否修改,我们保持默认依然回车即可,回车后脚本就会开始自动安装 pear 库了 6.安装的时候			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bolxqdM.html" rel="bookmark">SQL存储过程初探第1&sol;2页&lowbar;存储过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 一直用ASP+ACCESS来编写网页和公司的内部应用系统,内部应用系统也就是大家说的OA吧,这个我也不知道,公司又叫它ERP,反正不管什么,它是用来帮助公司处理日常工作的,简化劳动的.从来没用过存储过程,所有的添加,删除,修改都是在ASP里面写程序执行,代码很多.数据量少的时候没什么感觉,挺快的,可等到数据量大的时候,上W条记录查询,尤其是不分页都显示在一页里的时候情况就出现了,速度很慢,要10几秒才有反应,所以想到了要用SQL的存储过程来简化代码和加快程序的执行速度! 在学习了51JS里			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bB13Az.html" rel="bookmark" class="title">Photoshop给绿草上的人物调出韩系淡绿色</a>
					<div>
						图片以绿色为主,转为淡绿色是非常方便的.只需用调色工具把把绿色部分调淡,再用曲线等把图片暗部颜色调淡,整体看上去比较淡雅即可. 原图 &lt;点小图查看大图&gt; 最终效果 1.打开素材图片,创建可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvZw5M.html" rel="bookmark" class="title">把字符串放到规定的范围内&comma;超出的部分自动变为&period;&period;&period;完美解决</a>
					<div>
						解决|字符串 ylog.net主页里有最新日记和最新评论两项,日记的标题和评论的内容经常超出长度而自动换行,只能用难看两字形容,这让我头痛不已...首先想到的是截取一段,于是写了这个函数这种操作用js ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9VGVp.html" rel="bookmark" class="title">DevExpress GridControl如何设置复合表头或多行表头</a>
					<div>
						首先,DevExpress.XtraGrid的GridControl复合表头或多行表头的示例,界面如下图所示: 实现步骤: 1.将DevExpress的GridControl转换为BandedGrid ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKd2Op.html" rel="bookmark" class="title">如何实现PHP的TEA算法</a>
					<div>
						算法简单,而且效率高,每次可以操作8个字节的数据,加密解密的KEY为16字节,即包含4个int数据的int型数组,加密轮数应为8的倍数,一般比较常用的轮数为64,32,16,QQ原来就是用TEA16来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNv8Db.html" rel="bookmark" class="title">Fireworks制作转动的四叶草效果教程</a>
					<div>
						效果图: Png图: 1. 新建一个150*100px大小的画布,用&quot;星型工具&quot;画一个四叶草图案,为它加一个&quot;纯色阴影滤&quot;镜. 按F8转换为&quot;动画&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPnAGz.html" rel="bookmark" class="title">Dreamweaver 入门教程之表格设计</a>
					<div>
						表格是现代网页制作的一个重要组成部分.表格之所以重要是因为表格可以实现网页的精确排版和定位.本节教程我们分为两步来进行.首先看表格操作的一个实例.然后来看一些表格操作的基本方法.在开始制作表格之前,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAxwOb.html" rel="bookmark" class="title">DateDiff函数和DateAdd函数</a>
					<div>
						1.日期相加 DateAdd 函数 返回已添加指定时间间隔的日期. DateAdd(interval, number, date) DateAdd 函数的语法有以下参数 (1)interval 必选项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M627yNM.html" rel="bookmark" class="title">PPT目录页的四项基本原则</a>
					<div>
						PPT目录页的四项基本原则   原则一:易读性强 案例分析:这个目录页明显不适合用在演示中,下方的黄色明度过高致使标题文字难以辨识. 常用方法 1.为本文本添加色块衬底; 2.加大文本颜色与色块颜色的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRyWrqb.html" rel="bookmark" class="title">PhotoShop打造MM照片童话风格转手绘效果教程</a>
					<div>
						转手绘(又名:转鼠绘.仿手绘.仿鼠绘)是利用图片处理工具(photoshop),将人物或风景照片转变成类似手绘效果的一种图片处理方法. 全名:照片转手绘效果.是众多PS效果中复杂性比较大.技术要求相对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPJvQz.html" rel="bookmark" class="title">详解Word文档的备份与恢复</a>
					<div>
						word是我们最常用的文档处理工具软件,不管是做一篇文档,还是写一份材料,都是十分方便和实用的.然而在编写文档过程中,些许失误总是难免.那么,有没有办法可以在出现失误的情况下,还能够恢复操作纳? 实际 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRy0eeb.html" rel="bookmark" class="title">Win7系统桌面图标无法删除怎么办？</a>
					<div>
						  Win7系统桌面图标无法删除怎么办?下面小编就给大家带来Win7桌面图标删除不了的解决方法,一起来看看吧. 桌面快捷方式不能删除的常用的方法: 1.粉碎快捷方式 需要安装第三方工具. 2.通过注册 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7W5lb.html" rel="bookmark" class="title">让ppt中的数据动起来的方法</a>
					<div>
						  操作步骤 1.打开PowerPoint2010,在&quot;插入&quot;功能栏中找到&quot;插图&quot;,然后单击&quot;图表&quot;选项. 2.在弹出的&quot;插入图表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Z2g4b.html" rel="bookmark" class="title">wps2013文字怎样设置页面边距</a>
					<div>
						  1:打开或新建文档,按下图打开[页面设置]对话框,这是菜单栏打开方法 2:我们也可从工具栏打开[页面设置]对话框,方法是打开[页面布局]选项,点击[页边距]命令图标.两种方法不同,但目标一样,下面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDY0nKb.html" rel="bookmark" class="title">Win7系统麦克风正确设置方法</a>
					<div>
						  不要觉得直接把麦克风插进主机菊花就可以正常使用了,绝大多数情况下我们还需要进一步进行设置.下面系统之家小编就为大家介绍一下Win7系统麦克风正确设置方法. 我们把麦克风大概分类一下,首先介绍的是内 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42AlYM.html" rel="bookmark" class="title">win7怎么开启休眠</a>
					<div>
						  使用cmd命令进行开启,首先点击开始菜单,在&quot;搜索程序和文件&quot;中输入&quot;cmd&quot;,然后点击回车键.如下: 弹出如下图的界面,在其中最后的地方输入&quot;p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mywao8z.html" rel="bookmark" class="title">怎样解决Win7系统0x0000003B错误提示</a>
					<div>
						Win7系统在使用过程中,常碰到蓝屏现象.蓝屏又叫蓝屏死机,是微软的Windows系列操作系统在无法从一个系统错误中恢复过来时,为保护电脑数据文件不被破坏而强制显示的屏幕图像.蓝屏问题说大不大,说小不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Z873b.html" rel="bookmark" class="title">GlusterFS on ZFS on CentOS 6&period;x x64</a>
					<div>
						原文如下, 但是这里有几点不推荐按照原文来做. 1. zfs set sync=disabled sp1  (不推荐) 如果没有UPS的话, 不推荐关闭sync, 因为任何异常都可能会导致数据丢失.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaL5xM.html" rel="bookmark" class="title">asp&period;net 全部选中与取消操作&comma;选中后的删除&lpar;ajax&rpar;实现无刷新效果&lowbar;AJAX相关</a>
					<div>
						前台代码 复制代码 代码如下: :&lt;%@ Page Language=&quot;C#&quot; AutoEventWireup=&quot;true&quot; CodeFile=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze695wb.html" rel="bookmark" class="title">我的MYSQL学习心得（六） 函数</a>
					<div>
						这一节主要介绍MYSQL里的函数,MYSQL里的函数很多,我这里主要介绍MYSQL里有而SQLSERVER没有的函数 数学函数 1.求余函数MOD(X,Y) MOD(X,Y)返回x被y除后的余数,MO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR9JDz.html" rel="bookmark" class="title">asp&period;net-小白提问：我想做一个 ASP&period;net 后台导出Excel 并且设置它的页眉页脚及列宽。大神有例子吗？</a>
					<div>
						问题描述 小白提问:我想做一个 ASP.net 后台导出Excel 并且设置它的页眉页脚及列宽.大神有例子吗? 如图:我想做一个 ASP.net 后台导出Excel 并且设置它的页眉页脚及列宽.大神有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPvPmp.html" rel="bookmark" class="title">win7 64位 Eclipse开发java 找不到LoadLibraryAction&period;class</a>
					<div>
						问题描述 win7 64位 Eclipse开发java 找不到LoadLibraryAction.class 环境描述 win7 64位 Eclipse开发java ,该段程序是连接access数据库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAmK4p.html" rel="bookmark" class="title">浏览器删除cookie问题</a>
					<div>
						问题描述 浏览器删除cookie问题 如何删除浏览器的cookie,使用Response.Cookies.Clear()没有用 解决方案 浏览器删除cookie问题 解决方案二: jquery删除co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLGWnp.html" rel="bookmark" class="title">深入Protobuf源码－概述、使用以及代码生成实现</a>
					<div>
						概述 捣鼓hdfs.yarn.hbase.zookeeper的代码一年多了,是时候整理一下了.在hadoop (2.5.2)中protobuf是节点之间以及客户端和各个节点通信的基础序列化框架(协议) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RNqQb.html" rel="bookmark" class="title">socket消息流程介绍及其C代码实现</a>
					<div>
						在实际的软件开发工作中,经常会涉及到socket编程,也就是利用socket来完成消息的交互和命令的执行.本文通过一个C程序来讲解Linux下socket的整个消息执行流程. C程序示例 /***** ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKX1jb.html" rel="bookmark" class="title">后台分页　刷新-列表　分页＋局部刷新</a>
					<div>
						问题描述 列表 分页+局部刷新 问题描述:列表是从数据库动态获取的,分页采用后端分页形式. 页码之前是通过url传递的,想请教下大神,如何实现点击下一页通过局部刷新来显示列表内容.. 解决方案 aja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWv8mz.html" rel="bookmark" class="title">linux tomcat 的安装</a>
					<div>
						1.tomcat6 下载地址 http://tomcat.apache.org/download-60.cgi 下载的话,下载那个.tar.gz后缀名的即可. 好像在 Linux.Unix上tomca ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR8x0p.html" rel="bookmark" class="title">有关jsp-servlet中有两个setattribute方法在jsp页面怎么调用</a>
					<div>
						问题描述 servlet中有两个setattribute方法在jsp页面怎么调用 servlet中有两个setattribute方法在jsp页面怎么调用 解决方案 在jsp页面上直接el表达式获取后台 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNAKKM.html" rel="bookmark" class="title">中国银联信息处理中心存储及数据备份项目解决方案</a>
					<div>
						项目背景介绍: 随着我国经济的发展,银行卡的使用越来越广泛,银行卡跨行业务发展迅速.中国银联作为全国银行卡业务交换中心,负责统一规划和建设全国银行卡跨行信息交换网络,向成员机构提供跨 行和跨国的金融交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnZ61M.html" rel="bookmark" class="title">小弟比较穷没分，请各位大哥能把这道题写一下，兄弟万分感谢&excl;</a>
					<div>
						问题描述 给你一个数字,里面有重复数字,现在查处里面数字最大的的重复出现次数! 解决方案 解决方案二:看帖回帖一直是中国人的优良传统!每天回帖即可获得10分可用分!解决方案三:很明显,你在哭穷,根据C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0DONp.html" rel="bookmark" class="title">Jquery插件实现点击获取验证码后60秒内禁止重新获取&lowbar;jquery</a>
					<div>
						通过jquery.cookie.js插件可以快速实现&quot;点击获取验证码后60秒内禁止重新获取(防刷新)&quot;的功能 效果图: 先到官网(http://plugins.jquery.com ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
